"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.ParentChildExample = exports.NoLabel = exports.Invalid = exports.Interactive = exports.Indeterminate = exports.Disabled = exports.Default = exports.CustomSpacing = exports.CustomSize = exports.Checked = exports.CheckboxGroup = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Checkbox = _interopRequireDefault(require("./Checkbox"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var meta = {
  title: 'Example/Checkbox',
  component: _Checkbox.default
};
var _default = meta;
exports.default = _default;
// Basic checkbox
var Default = {
  args: {
    name: 'default-checkbox',
    value: 'default',
    label: 'Default checkbox'
  },
  parameters: {
    docs: {
      description: {
        story: 'The default checkbox in its unchecked state.'
      }
    }
  }
}; // Checked checkbox

exports.Default = Default;
var Checked = {
  args: {
    name: 'checked-checkbox',
    value: 'checked',
    label: 'Checked checkbox',
    checked: true
  },
  parameters: {
    docs: {
      description: {
        story: 'A checkbox in its checked state.'
      }
    }
  }
}; // Indeterminate checkbox

exports.Checked = Checked;
var Indeterminate = {
  args: {
    name: 'indeterminate-checkbox',
    value: 'indeterminate',
    label: 'Indeterminate checkbox',
    indeterminate: true
  },
  parameters: {
    docs: {
      description: {
        story: 'A checkbox in its indeterminate state, useful for representing partially selected states.'
      }
    }
  }
}; // Disabled checkbox

exports.Indeterminate = Indeterminate;
var Disabled = {
  args: {
    name: 'disabled-checkbox',
    value: 'disabled',
    label: 'Disabled checkbox',
    disabled: true
  },
  parameters: {
    docs: {
      description: {
        story: 'A disabled checkbox that cannot be interacted with.'
      }
    }
  }
}; // Invalid checkbox

exports.Disabled = Disabled;
var Invalid = {
  args: {
    name: 'invalid-checkbox',
    value: 'invalid',
    label: 'Invalid checkbox',
    invalid: true
  },
  parameters: {
    docs: {
      description: {
        story: 'A checkbox marked as invalid, typically used to indicate validation errors.'
      }
    }
  }
}; // No label checkbox

exports.Invalid = Invalid;
var NoLabel = {
  args: {
    name: 'nolabel-checkbox',
    value: 'nolabel',
    noLabel: true
  },
  parameters: {
    docs: {
      description: {
        story: 'A checkbox without a label.'
      }
    }
  }
}; // Custom size checkbox

exports.NoLabel = NoLabel;
var CustomSize = {
  args: {
    name: 'customsize-checkbox',
    value: 'customsize',
    label: 'Custom size checkbox (24px)',
    size: 24
  },
  parameters: {
    docs: {
      description: {
        story: 'A checkbox with a custom size (larger than default).'
      }
    }
  }
}; // Custom spacing checkbox

exports.CustomSize = CustomSize;
var CustomSpacing = {
  args: {
    name: 'customspacing-checkbox',
    value: 'customspacing',
    label: 'Custom spacing checkbox',
    spacing: 8
  },
  parameters: {
    docs: {
      description: {
        story: 'A checkbox with custom spacing between the checkbox and its label.'
      }
    }
  }
}; // Interactive checkbox example

exports.CustomSpacing = CustomSpacing;

var InteractiveCheckbox = function InteractiveCheckbox() {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      checked = _useState2[0],
      setChecked = _useState2[1];

  return /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "interactive-checkbox",
    value: "interactive",
    label: "Interactive checkbox (".concat(checked ? 'checked' : 'unchecked', ")"),
    checked: checked,
    onChange: function onChange(e) {
      return setChecked(e.target.checked);
    }
  });
};

var Interactive = {
  render: function render() {
    return /*#__PURE__*/_react.default.createElement(InteractiveCheckbox, null);
  },
  parameters: {
    docs: {
      description: {
        story: 'An interactive checkbox that updates its label based on its state.'
      }
    }
  }
}; // Checkbox group example

exports.Interactive = Interactive;

var CheckboxGroupExample = function CheckboxGroupExample() {
  var _useState3 = (0, _react.useState)([]),
      _useState4 = _slicedToArray(_useState3, 2),
      selectedOptions = _useState4[0],
      setSelectedOptions = _useState4[1];

  var handleChange = function handleChange(e) {
    var value = e.target.value;

    if (e.target.checked) {
      setSelectedOptions([].concat(_toConsumableArray(selectedOptions), [value]));
    } else {
      setSelectedOptions(selectedOptions.filter(function (option) {
        return option !== value;
      }));
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      gap: '12px'
    }
  }, /*#__PURE__*/_react.default.createElement("div", null, "Selected options: ", selectedOptions.join(', ') || 'None'), /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "options",
    value: "option1",
    label: "Option 1",
    checked: selectedOptions.includes('option1'),
    onChange: handleChange
  }), /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "options",
    value: "option2",
    label: "Option 2",
    checked: selectedOptions.includes('option2'),
    onChange: handleChange
  }), /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "options",
    value: "option3",
    label: "Option 3",
    checked: selectedOptions.includes('option3'),
    onChange: handleChange
  }));
};

var CheckboxGroup = {
  render: function render() {
    return /*#__PURE__*/_react.default.createElement(CheckboxGroupExample, null);
  },
  parameters: {
    docs: {
      description: {
        story: 'A group of checkboxes working together to select multiple options.'
      }
    }
  }
}; // Indeterminate Parent-Child Example

exports.CheckboxGroup = CheckboxGroup;

var ParentChildCheckboxes = function ParentChildCheckboxes() {
  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      parentChecked = _useState6[0],
      setParentChecked = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      parentIndeterminate = _useState8[0],
      setParentIndeterminate = _useState8[1];

  var _useState9 = (0, _react.useState)({
    child1: false,
    child2: false,
    child3: false
  }),
      _useState10 = _slicedToArray(_useState9, 2),
      children = _useState10[0],
      setChildren = _useState10[1];

  var updateParentState = function updateParentState(newChildren) {
    var checkedCount = Object.values(newChildren).filter(Boolean).length;
    setParentIndeterminate(checkedCount > 0 && checkedCount < Object.keys(newChildren).length);
    setParentChecked(checkedCount === Object.keys(newChildren).length);
  };

  var handleParentChange = function handleParentChange(e) {
    var newChecked = e.target.checked;
    setParentChecked(newChecked);
    setParentIndeterminate(false);
    var newChildren = {
      child1: newChecked,
      child2: newChecked,
      child3: newChecked
    };
    setChildren(newChildren);
  };

  var handleChildChange = function handleChildChange(e) {
    var _e$target = e.target,
        name = _e$target.name,
        checked = _e$target.checked;

    var newChildren = _objectSpread(_objectSpread({}, children), {}, _defineProperty({}, name, checked));

    setChildren(newChildren);
    updateParentState(newChildren);
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      gap: '8px'
    }
  }, /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "parent",
    value: "parent",
    label: "Select All",
    checked: parentChecked,
    indeterminate: parentIndeterminate,
    onChange: handleParentChange
  }), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      marginLeft: '24px',
      display: 'flex',
      flexDirection: 'column',
      gap: '8px'
    }
  }, /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "child1",
    value: "child1",
    label: "Item 1",
    checked: children.child1,
    onChange: handleChildChange
  }), /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "child2",
    value: "child2",
    label: "Item 2",
    checked: children.child2,
    onChange: handleChildChange
  }), /*#__PURE__*/_react.default.createElement(_Checkbox.default, {
    name: "child3",
    value: "child3",
    label: "Item 3",
    checked: children.child3,
    onChange: handleChildChange
  })));
};

var ParentChildExample = {
  render: function render() {
    return /*#__PURE__*/_react.default.createElement(ParentChildCheckboxes, null);
  },
  parameters: {
    docs: {
      description: {
        story: 'A parent checkbox with indeterminate state that controls multiple child checkboxes.'
      }
    }
  }
};
exports.ParentChildExample = ParentChildExample;